// If this code works, it was written by Svetlio Kapralov. If not, I don't know who wrote it.
package net.playerfinder.jsf.components.socialshare;

import javax.faces.application.ResourceDependencies;
import javax.faces.application.ResourceDependency;
import javax.faces.component.FacesComponent;
import javax.faces.component.UIOutput;

@FacesComponent(UISocialShare.COMPONENT_TYPE)
@ResourceDependencies({
		@ResourceDependency(name = "jquery.js", library = "pfjs"),
		@ResourceDependency(name = "pf.no.conflicts.js", library = "pfjs"),
		@ResourceDependency(name = "jquery.sharrre-1.3.4.js", library = "pfjs") })
public class UISocialShare extends UIOutput {

	public static final String COMPONENT_TYPE = "net.playerfinder.jsf.components.socialshare.UISocialShare";
	public static final String COMPONENT_FAMILY = "net.playerfinder.jsf.components";
	public static final String DEFAULT_RENDERER = "net.playerfinder.jsf.components.socialshare.UISocialShareRenderer";

	private final static String DEFAULT_EVENT = "change";

	protected enum PropertyKeys {
		layout, url, text, title, showGooglePlus, showFacebook, showTwitter, showLinkedIn;// ,
																							// showDigg,
																							// showDelicious;//,
																							// showPinterest;

		String toString;

		PropertyKeys(String toString) {
			this.toString = toString;
		}

		PropertyKeys() {
		}

		public String toString() {
			return ((this.toString != null) ? this.toString : super.toString());
		}
	}

	public UISocialShare() {
		setRendererType(DEFAULT_RENDERER);
	}

	@Override
	public String getFamily() {
		return COMPONENT_FAMILY;
	}

	@Override
	public String getDefaultEventName() {
		return DEFAULT_EVENT;
	}

	public java.lang.Integer getLayout() {
		return (java.lang.Integer) getStateHelper()
				.eval(PropertyKeys.layout, 0);
	}

	public void setLayout(java.lang.Integer layout) {
		getStateHelper().put(PropertyKeys.layout, layout);
	}

	public java.lang.String getUrl() {
		return (java.lang.String) getStateHelper().eval(PropertyKeys.url, "");
	}

	public void setUrl(java.lang.String url) {
		getStateHelper().put(PropertyKeys.url, url);
	}

	public java.lang.String getText() {
		return (java.lang.String) getStateHelper().eval(PropertyKeys.text, "");
	}

	public void setText(java.lang.String text) {
		getStateHelper().put(PropertyKeys.text, text);
	}

	public java.lang.String getTitle() {
		return (java.lang.String) getStateHelper().eval(PropertyKeys.title, "");
	}

	public void setTitle(java.lang.String title) {
		getStateHelper().put(PropertyKeys.title, title);
	}

	public void setShowGooglePlus(java.lang.Boolean value) {
		getStateHelper().put(PropertyKeys.showGooglePlus, value);
	}

	public java.lang.Boolean isShowGooglePlus() {
		return (java.lang.Boolean) getStateHelper().eval(
				PropertyKeys.showGooglePlus, false);
	}

	public void setShowFacebook(java.lang.Boolean value) {
		getStateHelper().put(PropertyKeys.showFacebook, value);
	}

	public java.lang.Boolean isShowFacebook() {
		return (java.lang.Boolean) getStateHelper().eval(
				PropertyKeys.showFacebook, false);
	}

	public void setShowTwitter(java.lang.Boolean value) {
		getStateHelper().put(PropertyKeys.showTwitter, value);
	}

	public java.lang.Boolean isShowTwitter() {
		return (java.lang.Boolean) getStateHelper().eval(
				PropertyKeys.showTwitter, false);
	}

	// public void setShowDigg(java.lang.Boolean value) {
	// getStateHelper().put(PropertyKeys.showDigg, value);
	// }
	//
	// public java.lang.Boolean isShowDigg() {
	// return (java.lang.Boolean) getStateHelper().eval(PropertyKeys.showDigg,
	// false);
	// }
	//
	// public void setShowDelicious(java.lang.Boolean value) {
	// getStateHelper().put(PropertyKeys.showDelicious, value);
	// }
	//
	// public java.lang.Boolean isShowDelicious() {
	// return (java.lang.Boolean) getStateHelper().eval(
	// PropertyKeys.showDelicious, false);
	// }

	public void setShowLinkedIn(java.lang.Boolean value) {
		getStateHelper().put(PropertyKeys.showLinkedIn, value);
	}

	public java.lang.Boolean isShowLinkedIn() {
		return (java.lang.Boolean) getStateHelper().eval(
				PropertyKeys.showLinkedIn, false);
	}

	// public void setShowPinterest(java.lang.Boolean value) {
	// getStateHelper().put(PropertyKeys.showPinterest, value);
	// }
	//
	// public java.lang.Boolean isShowPinterest() {
	// return (java.lang.Boolean) getStateHelper().eval(
	// PropertyKeys.showPinterest, false);
	// }

}